ORG 00H
EN BIT P3.5
RS BIT P3.3
RW BIT P3.4
D EQU P1
IO_M EQU P3.0

LCALL INIT_LCD

MOV DPTR, #MY_NAME
LCALL LCD_STRING


; SUB-ROUTINE USED AT START-UP --------------------
INIT_LCD: 
	LCALL DELAY_50MS
	MOV A, #30H
	LCALL LCD_CMD
	LCALL DELAY_1MS
    	LCALL DELAY_1MS
    	LCALL DELAY_1MS
    	LCALL DELAY_1MS
    	LCALL DELAY_1MS
	MOV A, #3CH		; DISPLAY ON/OFF
	LCALL LCD_CMD
	LCALL DELAY_1MS
	MOV A, #08H
	LCALL LCD_CMD
	LCALL DELAY_1MS
	LCALL DELAY_1MS
	MOV A, #06H
	LCALL LCD_CMD
	LCALL DELAY_1MS
	MOV A, #0CH
	LCALL LCD_CMD
	LCALL DELAY_1MS
	LCALL LCD_CLEAR
	RET
;-----------------------------------
; SENDING CODE TO THE COMMAND REGISTER
LCD_CMD:
    PUSH ACC
    PUSH DPL
    PUSH DPH
    MOV DPTR, #6000H        ;MOVE DPTR TO 6000H
    SETB IO_M        ;SET I/Om
    MOVX @DPTR, A        ;MOVE DATA TO DATABUS
    CLR IO_M        ;CLEAR I/Om
    CLR RS            ;RS = 0 (CMD REG SELECT)
    CLR RW            ;RW = 0 (WRITE SELECTED)
    SETB EN            ;E=1 FOR HIGH PULSE
    LCALL DELAY_1MS
    CLR EN            ;E=0 FOR H-TO-L PULSE
    SETB RW
    SETB RS
    POP DPH
    POP DPL
    POP ACC
    RET
;------------------------------------
; CLEARS THE SCREEN
LCD_CLEAR:
    PUSH ACC
    MOV A, #01H
    LCALL LCD_CMD
    LCALL DELAY_1MS
    LCALL DELAY_1MS
    ;MOV A, #80H
    ;LCALL LCD_CMD
    POP ACC
    RET

;-----------------------------------
; SENDING CODE TO THE COMMAND REGISTER (SEND CHAR)
LCD_DATA:
    PUSH ACC
    PUSH DPL
    PUSH DPH
    MOV DPTR, #6000H        ;MOVE DPTR TO 6000H
    SETB IO_M        ;SET I/Om
    MOVX @DPTR, A        ;MOVE DATA TO DATABUS
    ;LCALL DELAY_1MS
    CLR IO_M        ;CLEAR I/Om
    SETB RS            ;RS = 1 (DATA REG SELECT)
    CLR RW            ;RW = 0 (WRITE SELECTED)
    SETB EN            ;E=1 FOR HIGH PULSE
    LCALL DELAY_1MS
    CLR EN            ;E=0 FOR H-TO-L PULSE
    SETB RW
    CLR RS
    POP DPH
    POP DPL
    POP ACC
    RET
;----------------SECOND LINE 
SECOND_LINE:	; SUB-ROUTINE TO GO BACK TO THE SECOND LINE
	MOV A, #0C0H ; SET DDRAM ADDRESS ON SECOND LINE
	LCALL LCD_CMD
	RET
;--------------THIRD LINE
THIRD_LINE:	; SUB-ROUTINE TO GO BACK TO THE SECOND LINE
	MOV A, #094H ; SET DDRAM ADDRESS ON SECOND LINE
	LCALL LCD_CMD
	RET
;--------------THIRD LINE
FOURTH_LINE:	; SUB-ROUTINE TO GO BACK TO THE SECOND LINE
	MOV A, #0D4H ; SET DDRAM ADDRESS ON SECOND LINE
	LCALL LCD_CMD
	RET
;------------NEW DELAY
DEL_50uS:
    PUSH ACC
    PUSH 0
    MOV R0, #18
    DELAYING:
        DJNZ R0, DELAYING
    POP 0
    POP ACC
    RET
DELAY_300MS:
    PUSH ACC
    PUSH 0
    MOV R0, #6
    DELAY300:
        LCALL DELAY_50MS
        DJNZ R0, DELAY300
    POP 0
    POP ACC
    RET
DELAY_1MS:
    PUSH ACC
    PUSH 0
    MOV R0, #20
    DELAYING1:
        LCALL DEL_50uS
        DJNZ R0, DELAYING1
    POP 0
    POP ACC
    RET
DELAY_50MS:
    PUSH ACC
    PUSH 0
    MOV R0, #50
    DELAYING2:
        LCALL DELAY_1MS
        DJNZ R0, DELAYING2
    POP 0
    POP ACC
    RET
    
DELAY_20MS:
    PUSH ACC
    PUSH 0
    MOV R0, #20
    DELAYING3:
        LCALL DELAY_1MS
        DJNZ R0, DELAYING3
    POP 0
    POP ACC
    RET
;------------------------------------
;DELAY FOR THE CODE EXECUTION
DELAYS: MOV R5, #10
THIRD: MOV R6, #160
SECOND: MOV R7, #160

	DJNZ R7, $
	DJNZ R6, SECOND
	DJNZ R5, THIRD
	RET
;------------------------------------
;DELAY FOR THE CODE EXECUTION
DELAYS1: MOV R5, #2
THIRD1: MOV R6, #25
SECOND1: MOV R7, #50

	DJNZ R7, $
	DJNZ R6, SECOND1
	DJNZ R5, THIRD1
	RET

DELAYS11: MOV R5, #5
THIRD11: MOV R6, #100
SECOND11: MOV R7, #100

	DJNZ R7, $
	DJNZ R6, SECOND11
	DJNZ R5, THIRD11
	RET
;----------------LCD_STRING--------------------------------
LCD_STRING: ; FOR THE STRINGS THAT NEEDS TO BE SENT TO THE SCREEN
	CLR A
	MOVC A, @A+DPTR ; TRANSFER REG A CONTENT TO DATA POINTER
	JZ L2 		; EXIT OUT IF THE END IS REACHED
	LCALL LCD_DATA	; CALLS THE SROUTINE FOR CHARS IN MEM
	INC DPTR	; INCREMENT THE DATAPOINTER
	SJMP LCD_STRING	; LOOP BACK UNTIL ALL CHARS HAVE GONE THRU
L2:
	RET
;--------------LABELS------------------------------------
MY_NAME: DB ' David - Project 1', 00H
SOURCE_ADD: DB 'SOURCE ADDRESS: ', 00H
BLK_SIZE: DB 'BLOCK SIZE: ', 00H
DEST_ADDRESS: DB 'DESTINATION ADD: ', 00H
SEARCH_VAL: DB ' VALUE NEEDED: ', 00H
DUMP_EDIT_MENU: DB ' D: DUMP   E: EDIT', 00H
MOVE_FIND_MENU: DB ' B: MOVE   F: FIND', 00H
CLK_ADC_MENU: DB ' A: CLK    C: TEMP', 00H
NEW_ENTRY: DB ' NEW ENTRY: ', 00H
NOTFOUND: DB ' VALUE NOT FOUND!', 00H
EXIT_PROGRAM:
END
